
package cz.cuni.mff.corrector.expression;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * Regular subexpression for empty word.
 *
 * @author Martin Svoboda
 */
public class ExpressionEpsilon extends Expression {

    // -------------------------------------------------------------------------


    /**
     * Creates an instance of the empty regular subexpression.
     */
    protected ExpressionEpsilon() { }


    public ExpressionEpsilon duplicateExpression() {
        return new ExpressionEpsilon();
    }


    // -------------------------------------------------------------------------


    public Type getType() {
        return Type.EPSILON;
    }


    public String serializeExpression() {
        return TOKEN_RE_EPSILON;
    }


    public Set<String> getSymbols() {
        return new HashSet<String>();
    }
    
    
    protected void markSymbols(Provider provider) { }


    // -------------------------------------------------------------------------


    public boolean resolveEmpty() {
        this.allowsEmpty = true;
        return this.allowsEmpty;
    }

    public Set<String> resolveFirst() {
        Set<String> symbols = new HashSet<String>();
        return symbols;
    }

    public Set<String> resolveLast() {
        Set<String> symbols = new HashSet<String>();
        return symbols;
    }

    public Map<String, Set<String>> resolveFollow() {
        Map<String, Set<String>> mapping = new HashMap<String, Set<String>>();
        return mapping;
    }


    // -------------------------------------------------------------------------

}
