
package cz.cuni.mff.corrector.repair;

import cz.cuni.mff.corrector.instruction.Instruction;
import cz.cuni.mff.corrector.instruction.InstructionRemoveLeaf;
import cz.cuni.mff.corrector.intent.Intent;
import java.util.ArrayList;
import java.util.List;

/**
 * Node repair for delete subtree correction intent.
 *
 * @author Martin Svoboda
 */
public class NodeRepairDeleteSubtree extends NodeRepair {

    // -------------------------------------------------------------------------


    /**
     * Reference to the associated remove leaf repairing instruction.
     */
    private InstructionRemoveLeaf nodeInstruction;


    // -------------------------------------------------------------------------


    /**
     * Creates a new instance of a delete subtree node repair.
     * @param nodeInstruction Reference to the prepared defining instruction.
     */
    public NodeRepairDeleteSubtree(InstructionRemoveLeaf nodeInstruction) {
        this.nodeInstruction = nodeInstruction;
    }


    // -------------------------------------------------------------------------


    public List<Instruction> getInstructionsList() {
        List<Instruction> instructionSequence = new ArrayList<Instruction>(1);
        instructionSequence.add(this.nodeInstruction);
        return instructionSequence;
    }


    public int getRepairCost() {
        return this.nodeInstruction.getInstructionCost();
    }


    // -------------------------------------------------------------------------


    public Intent.Type getIntentType() {
        return Intent.Type.DELETE;
    }


    // -------------------------------------------------------------------------

}
