
package cz.cuni.mff.corrector.repair;

import cz.cuni.mff.corrector.instruction.Instruction;
import cz.cuni.mff.corrector.instruction.InstructionAddLeaf;
import cz.cuni.mff.corrector.intent.Intent;
import java.util.ArrayList;
import java.util.List;

/**
 * Node repair for insert subtree correction intent.
 *
 * @author Martin Svoboda
 */
public class NodeRepairInsertSubtree extends NodeRepair {

    // -------------------------------------------------------------------------


    /**
     * Reference to the associated add leaf repairing instruction.
     */
    private InstructionAddLeaf nodeInstruction;


    // -------------------------------------------------------------------------


    /**
     * Creates a new instance of an insert subtree node repair.
     * @param nodeInstruction Reference to the prepared defining instruction.
     */
    public NodeRepairInsertSubtree(InstructionAddLeaf nodeInstruction) {
        this.nodeInstruction = nodeInstruction;
    }


    // -------------------------------------------------------------------------


    public List<Instruction> getInstructionsList() {
        List<Instruction> instructionSequence = new ArrayList<Instruction>(1);
        instructionSequence.add(this.nodeInstruction);
        return instructionSequence;
    }


    public int getRepairCost() {
        return this.nodeInstruction.getInstructionCost();
    }


    // -------------------------------------------------------------------------


    public Intent.Type getIntentType() {
        return Intent.Type.INSERT;
    }


    // -------------------------------------------------------------------------

}
