
package cz.cuni.mff.corrector.instruction;

import static org.junit.Assert.assertEquals;
import org.junit.Test;

/**
 * Basic tests for instructions.
 * 
 * @author Martin Svoboda
 */
public class InstructionTest {
    
    // -------------------------------------------------------------------------


    /**
     * Tests generation of edit operations from instructions.
     */
    @Test
    public void testInstructions() {
        
        InstructionAddLeaf i1 = new InstructionAddLeaf("label");
        assertEquals("addLeaf(label)", i1.getTitleString());
        assertEquals("addLeaf(0, label)", i1.generateEditOperation().getOperationTitle());
        
        InstructionAddNode i2 = new InstructionAddNode("label", 3);
        assertEquals("addNode(3, label)", i2.getTitleString());
        assertEquals("addNode(0, 3, label)", i2.generateEditOperation().getOperationTitle());
        
        InstructionRemoveLeaf i3 = new InstructionRemoveLeaf();
        assertEquals("removeLeaf()", i3.getTitleString());
        assertEquals("removeLeaf(0)", i3.generateEditOperation().getOperationTitle());
        
        InstructionRemoveNode i4 = new InstructionRemoveNode();
        assertEquals("removeNode()", i4.getTitleString());
        assertEquals("removeNode(0)", i4.generateEditOperation().getOperationTitle());
        
        InstructionRenameLabel i5 = new InstructionRenameLabel("label");
        assertEquals("renameLabel(label)", i5.getTitleString());
        assertEquals("renameLabel(0, label)", i5.generateEditOperation().getOperationTitle());
        
    }
    
    
    // -------------------------------------------------------------------------
    
}
